/*****************ͷļ*************************/
#include "fsl_common.h"
#include "uart_Interrupt.h"
#include "fsl_uart.h"
#include "pin_Init.h"

/******************************************/
uint8_t demoRingBuffer[DEMO_RING_BUFFER_SIZE];
uint16_t txIndex; //ݼ
volatile uint16_t rxIndex; //ݼ

/*****************UART0ʼ*************************/
void UART0_InterrputInit()
{
    UART0_InitPins();   //UART0ųʼ
    uart_config_t config;   //
    UART_GetDefaultConfig(&config);
    config.baudRate_Bps = 2500000u;    //ò
    config.enableTx     = true; 
    config.enableRx     = true;
    UART_Init(UART0, &config, SystemCoreClock); //ʼ
    UART_EnableInterrupts(UART0, kUART_RxDataRegFullInterruptEnable | kUART_RxOverrunInterruptEnable);  //ʹRxж
    EnableIRQ(UART0_RX_TX_IRQn);    //ж
}

/*****************UART2ʼ*************************/
void UART2_InterrputInit()
{
    UART2_InitPins();   //UART2ųʼ
    uart_config_t config;   //
    UART_GetDefaultConfig(&config);
    config.baudRate_Bps = BOARD_DEBUG_UART_BAUDRATE;    //ò
    config.enableTx     = true; 
    config.enableRx     = true;
    UART_Init(DEMO_UART, &config, SystemCoreClock); //ʼ
    UART_EnableInterrupts(DEMO_UART, kUART_RxDataRegFullInterruptEnable | kUART_RxOverrunInterruptEnable);  //ʹRxж
    EnableIRQ(UART2_RX_TX_IRQn);    //ж
    UART_WriteByte(DEMO_UART, demoRingBuffer[txIndex]); //һ֡ݣһֽڣ8λ
}

uint16_t UART0_IRQ_Count = 0;
/*****************UART0жϷ**********************/
void UART0_RX_TX_IRQHandler(void)
{
    uint16_t data;
    UART0_IRQ_Count ++;
    UART0_IRQ_Count %= 1000;
    if ((kUART_RxDataRegFullFlag | kUART_RxOverrunFlag) & UART_GetStatusFlags(UART0))   //յݱ־
    {
        data = UART_ReadByte(UART0);
        if (((rxIndex + 1) % DEMO_RING_BUFFER_SIZE) != txIndex) //
        {
            demoRingBuffer[rxIndex] = data;
            rxIndex++;
            rxIndex %= DEMO_RING_BUFFER_SIZE;
        }
    } 
    /*յݷ*/
    if ((kUART_TxDataRegEmptyFlag & UART_GetStatusFlags(DEMO_UART)) && (rxIndex != txIndex))    //жϱ־
        {
            UART_WriteByte(DEMO_UART, demoRingBuffer[txIndex]); //һ֡ݣһֽڣ8λ
            txIndex++;
            txIndex %= DEMO_RING_BUFFER_SIZE;
        } 
    SDK_ISR_EXIT_BARRIER;
}

/*****************UART2жϷ**********************/
void UART2_RX_TX_IRQHandler(void)
{
    uint16_t data;
    if ((kUART_RxDataRegFullFlag | kUART_RxOverrunFlag) & UART_GetStatusFlags(DEMO_UART))   //յݱ־
    {
        data = UART_ReadByte(DEMO_UART);
        if (((rxIndex + 1) % DEMO_RING_BUFFER_SIZE) != txIndex) //
        {
            demoRingBuffer[rxIndex] = data;
            rxIndex++;
            rxIndex %= DEMO_RING_BUFFER_SIZE;
        }
    }
    /*յݷ*/
    if ((kUART_TxDataRegEmptyFlag & UART_GetStatusFlags(DEMO_UART)) && (rxIndex != txIndex))    //жϱ־
        {
            UART_WriteByte(DEMO_UART, demoRingBuffer[txIndex]); //һ֡ݣһֽڣ8λ
            txIndex++;
            txIndex %= DEMO_RING_BUFFER_SIZE;
        } 
    SDK_ISR_EXIT_BARRIER;
}


